//brilconc.cpp - ajusta brilho/contraste no sistema CieLab
#include <cekeikon.h>
void brilconc(int argc, char** argv) {
  if (argc!=5) {
    printf("BrilConC: Ajusta brilho/contraste de Mat_<COR> no sistema CieLab\n");
    printf("BrilConC ent.ppm sai.ppm brilho contraste\n");
    printf("  brilho e contraste no intervalo -1.0 a +1.0\n");
    erro("Erro: Numero de argumentos invalido");
  }

  double brilho;
  convArg(brilho,argv[3]);
  if (brilho<-1.0 || 1.0<brilho) xerro1("Erro: Brilho fora do intervalo");

  double contraste;
  convArg(contraste,argv[4]);
  if (contraste<-1.0 || 1.0<contraste) xerro1("Erro: contraste fora do intervalo");
  
  Mat_<COR> ent; le(ent,argv[1]);
  Mat_<COR> lab; cvtColor(ent,lab,CV_BGR2Lab);
  vector< Mat_<GRY> > lab_planes(3);
  split(lab, lab_planes);  // now we have the L image in lab_planes[0]
  
  Mat_<FLT> light; converte(lab_planes[0], light);
  for (unsigned i=0; i<light.total(); i++)
    if (contraste<0.0) // contraste negativo
      light(i)=(light(i)+brilho-0.5)*(1.0+contraste)+0.5;
    else if (contraste<1.0) // contraste positivo ou zero
      light(i)=(light(i)+brilho-0.5)*(1.0/(1.0-contraste))+0.5;
    else // contraste = 1
      light(i)=(light(i)+brilho-0.5)/epsilon+0.5;
  converte(light,lab_planes[0]);  
  
  merge(lab_planes,lab);
  Mat_<COR> sai;
  cvtColor(lab,sai,CV_Lab2BGR);
  imp(sai,argv[2]);
}
