//brilrgb.cpp - Ajusta brilho/contraste de cada plano RGB
#include <cekeikon.h>
void brilrgb(int argc, char** argv) {
  if (argc!=5) {
    printf("BrilRGB: Ajusta brilho/contraste de Mat_<COR> em cada plano RGB\n");
    printf("BrilRGB ent.ppm sai.ppm brilho contraste\n");
    printf("  brilho e contraste no intervalo -1.0 a +1.0\n");
    erro("Erro: Numero de argumentos invalido");
  }

  double brilho;
  convArg(brilho,argv[3]);
  if (brilho<-1.0 || 1.0<brilho) xerro1("Erro: Brilho fora do intervalo");

  double contraste;
  convArg(contraste,argv[4]);
  if (contraste<-1.0 || 1.0<contraste) xerro1("Erro: contraste fora do intervalo");
  
  Mat_<COR> ent; le(ent,argv[1]);
  Mat_<CORF> entf; converte(ent,entf);
  
  for (unsigned i=0; i<entf.total(); i++)
    for (unsigned p=0; p<3; p++) 
      if (contraste<0.0) // contraste negativo
        entf(i)[p]=(entf(i)[p]+brilho-0.5)*(1.0+contraste)+0.5;
      else if (contraste<1.0) // contraste positivo ou zero
        entf(i)[p]=(entf(i)[p]+brilho-0.5)*(1.0/(1.0-contraste))+0.5;
      else // contraste = 1
        entf(i)[p]=(entf(i)[p]+brilho-0.5)/epsilon+0.5;

  Mat_<COR> sai; converte(entf,sai);  
  imp(sai,argv[2]);
}
