#include <cekeikon.h>

void distc(int argc, char** argv) {
  Mat_<COR> a,b;

  if (argc!=3) {
    printf("DistC: Calcula distancia entre duas imagens coloridas.\n");
    erro("DistC ent1.ppm ent2.ppm");
  }
  le(a,argv[1]); le(b,argv[2]);
  if (a.size()!=b.size()) erro("Erro: Dimensoes diferentes.\n");
  int np=a.total();
  int nd=0;
  double ar,ag,ab,q,dq;
  ar=ag=ab=q=dq=0.0;
  double dqn=0.0;
  int dr,dg,db;

  for (int l=0; l<b.rows; l++)
    for (int c=0; c<b.cols; c++) {
      dr=abs(a(l,c)[2]-b(l,c)[2]);
      dg=abs(a(l,c)[1]-b(l,c)[1]);
      db=abs(a(l,c)[0]-b(l,c)[0]);
      if (dr!=0 || dg!=0 || db!=0) {
        nd++; ar+=dr; ag+=dg; ab+=db; q=q+sqrt(double(dr*dr+dg*dg+db*db));
        dq+=dr*dr+dg*dg+db*db;
        dqn+=elev2(dr/255.0)+elev2(dg/255.0)+elev2(db/255.0);
      }
    }

  printf("Linhas=%d Colunas=%d Pixels=%d\n",a.rows,a.rows,np);
  printf("Numero de pixels diferentes......: %20d\n",nd);
  printf("%% de pixels diferentes...........: %19.4f%%\n",(100.0*nd)/np);
  printf("\n");
  printf("Erro em modulo red...............: %20.0f\n",ar);
  printf("Media do erro red (max=255). ....: %20.4f\n",ar/np);
  printf("Erro em modulo green.............: %20.0f\n",ag);
  printf("Media do erro green (max=255)....: %20.4f\n",ag/np);
  printf("Erro em modulo blue..............: %20.0f\n",ab);
  printf("Media do erro blue (max=255).....: %20.4f\n",ab/np);
  printf("\n");
  printf("Media dist. Manhattan (max=255)..: %20.4f\n",(ar+ag+ab)/(3*np));
  printf("Media dist. Manhattan (max=765)..: %20.4f\n",(ar+ag+ab)/(np));
  printf("Media dist. Manhattan (max=100)..: %20.4f%%\n",(ar+ag+ab)/(3*np*2.55));
  printf("Media dist. euclid. (max=441)....: %20.4f\n",q/np);
  printf("Media dist. euclid. (max=100)....: %20.4f%%\n",q/(np*4.416729559));
  printf("Media dist. euclid. quad. .......: %20.4f\n",dq/np);
  printf("Raiz media dist. euc. quad. .....: %20.4f\n",sqrt(dq/np));
  printf("MSE (normalizando para [0,1])....: %20.6f\n",dqn/(3*np));
  printf("RMSE  (normalizando para [0,1])..: %20.6f\n",sqrt(dqn/(3*np)));
}
