#include <cekeikon.h>

ImgLcb<COR> grudah(ImgLcb<COR> a1, ImgLcb<COR> a2, int nespaco, COR backg)
{ int nc=a1.cols+nespaco+a2.cols; int nl=max(a1.rows,a2.rows);
  ImgLcb<COR> b(nl,nc,backg);
  for (int c=0; c<a1.cols; c++)
    for (int l=0; l<a1.rows; l++)
      b(l,c)=a1(l,c);
  for (int c=a1.cols+nespaco; c<nc; c++)
    for (int l=0; l<a2.rows; l++)
      b(l,c)=a2(l,c-a1.cols-nespaco);
  return b;
}

ImgLcb<COR> grudav(ImgLcb<COR> a1, ImgLcb<COR> a2, int nespaco, COR backg)
{ int nl=a1.rows+nespaco+a2.rows; int nc=max(a1.cols,a2.cols);
  ImgLcb<COR> b(nl,nc,backg);
  for (int l=0; l<a1.rows; l++)
    for (int c=0; c<a1.cols; c++)
      b(l,c)=a1(l,c);
  for (int l=a1.rows+nespaco; l<nl; l++)
    for (int c=0; c<a2.cols; c++)
      b(l,c)=a2(l-a1.rows-nespaco,c);
  return b;
}

void grudac(int argc, char **argv) {
  if (argc!=5 && argc!=6 && argc!=9) {
    printf("GRUDAC: Cola duas imagens coloridas\n");
    printf("GRUDAC arqent1.tga arqent2.tga arqsai.tga H/V [nespaco=0] [bgRed bgGre bgBlu]\n");
    printf("  backg default=branco\n");
    erro("Erro: Numero de argumentos invalido");
  }

  char modo=toupper(argv[4][0]);
  if (modo!='H' && modo!='V') erro("Erro: modo deve ser H ou V");

  int nespaco=0;
  if (argc>=6) {
    if (sscanf(argv[5],"%d",&nespaco)!=1) erro("Erro: leitura de nespaco");
  }

  COR backg(255,255,255);
  if (argc>=9) {
    int red,gre,blu;
    if (sscanf(argv[6],"%d",&red)!=1) erro("Erro: leitura bgRed");
    if (sscanf(argv[7],"%d",&gre)!=1) erro("Erro: leitura bgGre");
    if (sscanf(argv[8],"%d",&blu)!=1) erro("Erro: leitura bgBlu");
    backg=COR(red,gre,blu);
  }

  ImgLcb<COR> a1,a2;
  le(a1,argv[1]); le(a2,argv[2]);
  a1.backg=backg; a2.backg=backg;

  if (modo=='V') {
    ImgLcb<COR> b=grudav(a1,a2,nespaco,backg);
    imp(b,argv[3]);
  } else {
    ImgLcb<COR> b=grudah(a1,a2,nespaco,backg);
    imp(b,argv[3]);
  }
}

