CPP := $(wildcard *.cpp)
CPP := $(notdir $(CPP))
OBJ := $(patsubst %.cpp,%.oc2,$(CPP)) 
OBJ := $(notdir $(OBJ))
EXE := $(CEK5_PATH)/cekeikon/bin/kcek

CXXFLAGS := -fmax-errors=2 -c -O3 -Wall -std=gnu++14 -fPIC -Wno-unused-result `pkg-config $(CEK5_PATH)/opencv2cpu/lib/pkgconfig/opencv.pc --cflags` -I. -I$(CEK5_PATH)/cekeikon/src
LDFLAGS := -s `pkg-config $(CEK5_PATH)/opencv2cpu/lib/pkgconfig/opencv.pc --libs` -lcekeikon2 -L$(CEK5_PATH)/cekeikon/bin 

all: $(EXE)

$(EXE): $(OBJ)
	$(CXX) $(OBJ) -o $@ $(LDFLAGS)

$(OBJ): %.oc2: %.cpp 
	$(CXX) $< -o $@ $(CXXFLAGS)

.PHONY: clean
clean:
	rm -f $(OBJ)
	rm -f $(EXE)

.PHONY: debug
debug:
	@echo $(CPP)
	@echo $(OBJ)
	@echo $(EXE)
	@echo $(CXXFLAGS)
	@echo $(LDFLAGS)
