#include <cekeikon.h>

void rotacaoc(int argc, char** argv)
{
  if (argc!=4 && argc!=5 && argc!=7) {
    printf("RotacaoC ent.tga sai.tga angulo [n/b/c/l] [lc cc]\n");
    printf("  angulo em graus, sentido anti-horario\n");
    printf("  n=nearest b=bilinear c=cubico(default) l=lanczos a=area\n");
    printf("  lc=linha central cc=coluna central. Default=centro da imagem\n");
    erro("Erro: numero de parametros");
  }

  double grau;
  if (sscanf(argv[3],"%lf",&grau)!=1) erro("Erro: leitura de angulo");

  char modo='c';
  if (argc>=5) modo=tolower(argv[4][0]);
  int imodo=0;
  if (modo=='n') imodo=INTER_NEAREST;
  else if (modo=='b') imodo=INTER_LINEAR;
  else if (modo=='c') imodo=INTER_CUBIC;
  else if (modo=='l') imodo=INTER_LANCZOS4;
  else if (modo=='a') imodo=INTER_AREA;
  else erro("Erro: modo deve ser n/b/c/l");
  
  Mat_<COR> a; le(a,argv[1]); 

  int lc=a.rows/2; int cc=a.cols/2;
  if (argc>=7) {
    if (sscanf(argv[5],"%d",&lc)!=1) erro("Erro: leitura lc");
    if (sscanf(argv[6],"%d",&cc)!=1) erro("Erro: leitura cc");
  }

  Mat_<COR> b;
  Mat_<double> m=getRotationMatrix2D(Point2f(cc,lc), grau, 1);
  warpAffine(a, b, m, a.size(), imodo, BORDER_CONSTANT, Scalar(255,255,255));
  imp(b,argv[2]);
}

