//subimc.cpp
#include <cekeikon.h>
#include <cstring>

void subimc(int argc, char** argv) { 
  int nl,nc,l,c,li,ci,lf,cf,ql,qc;

  if (argc<2) {
    printf(
      "SubImC ent.ppm [sai.ppm li ci lf/ql cf/qc (co ul br)]\n"
      "  Retira uma subimagem colorida ou mostra tamanho da imagem.\n"
      "SubImC ent.ppm\n"
      "  Mostra tamanho da imagem ent.ppm.\n"
      "SubImC ent.ppm sai.ppm li ci lf cf [co]\n"
      "  Retira subimagem de (li,ci) ate (lf,cf).\n"
      "  A numeracao vai do zero ate tam-1.\n"
      "SubImC ent.ppm sai.ppm li ci ql qc ul\n"
      "  Retira subimagem tamanho ql*qc a partir de (li,ci).\n"
      "  A numeracao comeca no canto superior esquerdo (ul).\n"
      "SubImC ent.ppm sai.ppm li ci ql qc br\n"
      "  Retira subimagem tamanho ql*qc a partir de (li,ci).\n"
      "  A numeracao comeca no canto inferior direito (br).\n"
    );
    erro("Erro: Numero de argumentos invalido");
  }

  ImgAtb<COR> a; le(a,argv[1]); a.backg=COR(0,0,0);
  printf("Arquivo entrada: Linhas=%d colunas=%d\n",a.rows,a.cols);

  if (argc==2) exit(0);
  else if (argc!=7 && argc!=8) erro("Erro: Numero de argumentos invalido");

  ImgAtb<COR> b;
  int modo=0; //0=co 1=ul 2=br
  if (argc==8) {
    string st2=minuscula(argv[7]);
    if (st2=="ul") modo=1;
    if (st2=="br") modo=2;
  }

  int err=sscanf(argv[3],"%d",&li);
  if (err!=1) erro("Erro leitura li");
  err=sscanf(argv[4],"%d",&ci);
  if (err!=1) erro("Erro leitura ci");
  err=sscanf(argv[5],"%d",&lf);
  if (err!=1) erro("Erro leitura lf");
  ql=lf;
  err=sscanf(argv[6],"%d",&cf);
  if (err!=1) erro("Erro leitura cf");
  qc=cf;

  if (modo==0) { //co
    nl=lf-li+1; nc=cf-ci+1;
    if (nl<=0 || nc<=0) erro("Erro: nl ou nc nao-positivo");
    b.create(nl,nc);
    for (l=0; l<nl; l++)
      for (c=0; c<nc; c++)
        b(l,c)=a(l+li,c+ci);
    imp(b,argv[2]);
    printf("Arquivo saida: Linhas=%d colunas=%d\n",b.rows,b.cols);
  } else if (modo==1) { //ul
    nl=ql; nc=qc;
    if (nl<=0 || nc<=0) erro("Erro: nl ou nc nao-positivo");
    b.create(nl,nc);
    for (l=li; l<li+nl; l++)
      for (c=ci; c<ci+nc; c++)
        b(l-li,c-ci)=a(l,c);
    imp(b,argv[2]);
    printf("Arquivo saida: Linhas=%d colunas=%d\n",b.rows,b.cols);
  } else if (modo==2) { //br
    nl=ql; nc=qc;
    if (nl<=0 || nc<=0) erro("Erro: nl ou nc nao-positivo");
    b.create(nl,nc);
    lf=li; cf=ci;
    li=li-nl+1; ci=ci-nc+1;
    printf("li=%d ci=%d lf=%d cf=%d\n",li,ci,lf,ci);
    for (l=li; l<=lf; l++)
      for (c=ci; c<=cf; c++)
        b(l-li,c-ci)=a(l,c);
    imp(b,argv[2]);
    printf("Arquivo saida: Linhas=%d colunas=%d\n",b.rows,b.cols);
  }
}

