// CLAHEG = CLAHE para imagens em niveis de cinzas
// Linke com OpenCV3
// compila claheg -c -v3
#include <cekeikon.h>

int main(int argc, char** argv) {
  const char* keys =
    " curto| longo    |default| explicacao\n"
    " -c   | -clip    | 40    | clip histogram limit\n"
    " -t   | -tile    |  8    | use 8x8 tile grid size\n";

  if (argc<3) {
    printf("claheg: Contrast Limited Adaptive Histogram Equalization (GRY)\n");
    printf("claheg ent.pgm sai.pgm [opcoes]\n");
    printf("%s",keys);
    erro("Erro: Numero de argumentos invalido");
  }
  
  ArgComando cmd(argc,argv);
  string nomeent=cmd.getCommand(0);
  string nomesai=cmd.getCommand(1);
  double clip=cmd.getDouble("-c","-clip",40.0);
  int tile=cmd.getInt("-t","-tile",8);
  cmd.leuTodos();

  Mat_<GRY> ent; le(ent,nomeent);

  Ptr<CLAHE> clahe = createCLAHE();
  clahe->setClipLimit(clip);
  clahe->setTilesGridSize(Size(tile,tile));
  
  Mat_<GRY> sai;
  clahe->apply(ent,sai);
  imp(sai,nomesai);
}
