CXXFLAGS := -fmax-errors=2 -O3 -std=gnu++14 -fPIC -Wno-unused-result `pkg-config $(CEK5_PATH)/opencv2cpu/lib/pkgconfig/opencv.pc --cflags` -I. -I$(CEK5_PATH)/cekeikon/src

LDFLAGS := -s `pkg-config $(CEK5_PATH)/opencv2cpu/lib/pkgconfig/opencv.pc --libs` -lcekeikon2 -L$(CEK5_PATH)/cekeikon/bin

CXX3FLAGS := -fmax-errors=2 -O3 -std=gnu++14 -fPIC -Wno-unused-result `pkg-config $(CEK5_PATH)/opencv3cpu/lib/pkgconfig/opencv.pc --cflags` -I. -I$(CEK5_PATH)/cekeikon/src

LD3FLAGS := -s `pkg-config $(CEK5_PATH)/opencv3cpu/lib/pkgconfig/opencv.pc --libs` -lcekeikon3 -L$(CEK5_PATH)/cekeikon/bin

all: $(CEK5_PATH)/cekeikon/bin/bestbud $(CEK5_PATH)/cekeikon/bin/claheg $(CEK5_PATH)/cekeikon/bin/clahec

$(CEK5_PATH)/cekeikon/bin/bestbud: bestbud.cpp 
	$(CXX) $< -o $@ $(CXXFLAGS) $(LDFLAGS) -fopenmp

$(CEK5_PATH)/cekeikon/bin/claheg: claheg.cpp
	$(CXX) $< -o $@ $(CXX3FLAGS) $(LD3FLAGS) 

$(CEK5_PATH)/cekeikon/bin/clahec: clahec.cpp
	$(CXX) $< -o $@ $(CXX3FLAGS) $(LD3FLAGS) 

.PHONY: clean
clean:
	rm -f $(CEK5_PATH)/cekeikon/bin/bestbud
	rm -f $(CEK5_PATH)/cekeikon/bin/claheg
	rm -f $(CEK5_PATH)/cekeikon/bin/clahec

