CPP := $(wildcard *.cpp)
CPP := $(notdir $(CPP))

#Se estiver no Raspberry, elimina programas da lista NONFREE
NONFREE := descript.cpp surf.cpp
ifneq ($(OS),Windows_NT)
  UNAME_M := $(shell uname -m)
  ifneq ($(filter arm%,$(UNAME_M)),)
    CPP := $(filter-out $(NONFREE),$(CPP))
  endif
endif

OBJ := $(patsubst %.cpp,%.orp,$(CPP)) 
OBJ := $(notdir $(OBJ))
EXE := $(patsubst %.cpp, $(CEK5_PATH)/cekeikon/bin/%, $(CPP))

CXXFLAGS := -fmax-errors=2 -c -O3 -Wall -std=gnu++14 -fPIC -Wno-unused-result `pkg-config opencv --cflags` -I. -I$(CEK5_PATH)/cekeikon/src
LDFLAGS := -s `pkg-config opencv --libs` -lcekeikon -L$(CEK5_PATH)/cekeikon/bin

all: $(EXE)

#Preste atencao na linha abaixo. Que interessante!
$(EXE): $(CEK5_PATH)/cekeikon/bin/%: %.orp
	$(CXX) $< -o $@ $(LDFLAGS)

$(OBJ): %.orp: %.cpp 
	$(CXX) $< -o $@ $(CXXFLAGS)

.PHONY: clean
clean:
	rm -f $(OBJ)
	rm -f $(EXE)

.PHONY: debug
debug:
	@echo $(CPP)
	@echo $(OBJ)
	@echo $(EXE)
	@echo $(CXXFLAGS)
	@echo $(LDFLAGS)
