#include <cekeikon.h>

void gradiente4(Mat_<GRY> a, M3d_<SHT>& d)
// Calcula gradiente nas 4 direcoes: 3:00, 4:30, 6:00, 7:30
{ int vd[]={4, a.rows, a.cols};
  d.create(3,vd);
  
  Mat_<SHT> e=fatia(d,0);
  FLT vf300[]={-1, 0, 1};
  Mat_<FLT> f300(1,3,vf300);
  filter2D(a, e, -1, f300, Point(-1,-1), 128, BORDER_REPLICATE); 
  
  e=fatia(d,1);
  FLT vf430[]={-1, 0, 0,
                0, 0, 0,
                0, 0, 1};
  Mat_<FLT> f430(3,3, vf430);
  filter2D(a, e, -1, f430, Point(-1,-1), 128, BORDER_REPLICATE); 

  e=fatia(d,2);
  FLT vf600[]={-1, 
                0, 
                1};
  Mat_<FLT> f600(3,1, vf600);
  filter2D(a, e, -1, f600, Point(-1,-1), 128, BORDER_REPLICATE); 

  e=fatia(d,3);
  FLT vf730[]={ 0, 0,-1,
                0, 0, 0,
                1, 0, 0};
  Mat_<FLT> f730(3,3, vf730);
  filter2D(a, e, -1, f730, Point(-1,-1), 128, BORDER_REPLICATE); 
}

void riff(int argc, char** argv)
{ if (argc!=2) erro("riff ent.pgm");
  Mat_<GRY> a; le(a,argv[1]);
  M3d_<SHT> d; gradiente4(a,d);

  //Mat_<SHT> e=fatia(d,0); cout << e;
}

//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< main <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
const char about[]=
"< RIFF: Rotation-invariant template matching baseado em RIFF>\n"
"_______________________________________________________________________________\n";

const char help[]=
"Programas:\n"
"RIFF      - RIFF\n"
"...............................................................................\n";

int main(int argc, char** argv)
{
  if (argc<2) {
    printf(about);
    printf("%s",help);
    erro("Erro: Numero de argumentos invalido");
  } else {
    int t1=centseg();
    string comando=minuscula(argv[1]);
    if      (comando=="riff")      riff(argc-1,&argv[1]);
    else erro("Erro: Programa inexistente ",comando.c_str());
    t1=centseg()-t1;
    printf("Tempo gasto=%d.%02ds\n",t1/100,t1%100);
  }
}


