#include <cekeikon.h>

Mat_<COR> limiariza(Mat_<COR> a, Mat_<COR> b, int limiar)
{ Mat_<COR> d;
  absdiff(a,b,d);
  for (unsigned i=0; i<d.total(); i++) {
    GRY b=max3(d(i)[0],d(i)[1],d(i)[2]);
    if (b>25) d(i)=COR(0,0,255);
    else d(i)=a(i);
  }
  return d;
}

int main(int argc, char** argv) 
{ if (argc<2) {
    printf("SubBk: Subtrai background do webcam\n");
    printf("SubBk limiar (limiar razoavel=25)\n");
    printf("  Backg e' pego 1s apos o inicio\n");
    printf("  Backg e' pego quando apertar ENTER\n");
    printf("  Aperte ESC para sair\n");
    erro("Erro: Numero de argumentos invalido");
  }
  int limiar; convArg(limiar,argv[1]);

  VideoCapture w(0);
  if (!w.isOpened()) erro("Erro: Abertura de webcam");

  Mat_<COR> a,b,d;
  for (int i=0; i<30; i++) {
    w >> a; flip(a,a,1);
    waitKey(30);
  }
  printf("\07");
  a.copyTo(b);

  namedWindow("janela",0);
  while (true)  {
    w >> a; flip(a,a,1);
    d=limiariza(a,b,limiar);
    imshow("janela",d);
    int ch=waitKey(30);
    if (ch==13) { printf("\07"); a.copyTo(b); }
    else if (ch==27) break;
  }
}
