//fonte1.cpp
#include <GL/freeglut.h>
#include <cekeikon.h>

// funcao biblioteca
Vec3f normal(Vec3f a, Vec3f b, Vec3f c)
{ Vec3f d1=b-a;
  Vec3f d2=c-a;
  Vec3f d=versor(produtoVet(d1,d2));
  return d;
}

void cvtColor(Vec3f ent, Vec3f& sai, int code)
{ Mat_<Vec3f> entm(1,1,ent);
  Mat_<Vec3f> saim;
  cvtColor(entm,saim,code);
  sai=saim(0);
}

// constantes e variaveis globais do programa
int fps=30;
float duracaoMs=1000.0/fps;
float duracaoS =1.0/fps;
float olho=0;
float olhoM=0.5;
int maxAge=5*fps;

int nl,nc;
VideoWriter video;
Mat_<COR> imagem;

// tipos do programa
int bolasPorQuadro=20;
float raioBola=0.05;
float hue=0;
struct BOLA {
  Vec3f p;     // Position in space
  Vec3f v;  // Velocity vector
  Vec3f cor;     // Color of particle
  int age;      // Age of particle (0 = newborn)
  BOLA() { 
    p=Vec3f(0,1,0); 
    float a=M_2PI*myuniform(); 
    v=3*Vec3f(cos(a), 2.0+0.9*(myuniform()-0.5) ,sin(a)); 

    Vec3f hls(hue,0.5,1.0);
    hue+=0.2; if (hue>360) hue=0;
    cvtColor(hls,cor,CV_HLS2RGB); 

    age=0; 
  }
};

vector<BOLA> bolas;
const Vec3f gravidade(0,-10,0);

void material(float red, float gre, float blu)
{ GLfloat mat_ambient[] = { 0.5f*red, 0.5f*gre, 0.5f*blu, 1.0f };
  glMaterialfv(GL_FRONT, GL_AMBIENT, mat_ambient);
  GLfloat mat_diffuse[] = { 0.8f*red, 0.8f*gre, 0.8f*blu, 1.0f };
  glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
  GLfloat mat_specular[] = { 0.7, 0.7, 0.7, 1.0 };
  glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
  GLfloat mat_shininess[] = { 30.0 };
  glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
}

void quadrado(int x, int z, float red, float gre, float blu)
{ material(red,gre,blu);
  glBegin(GL_QUADS);
    glNormal3f(0, 1, 0);
    glVertex3f(x  , 0, z  );
    glVertex3f(x  , 0, z+1);
    glVertex3f(x+1, 0, z+1);
    glVertex3f(x+1, 0, z  );
  glEnd();
}

void desenhaAtualizaBolas(void)
{ 
  if (int(bolas.size()/bolasPorQuadro)%20==1)
    printf("nbolas=%u\n",unsigned(bolas.size()));

  //desenha
  for (unsigned i=0; i<bolas.size(); i++) {
    BOLA bola=bolas[i];
    if (bola.age<maxAge) {
      glPushMatrix();
      material(bola.cor[0],bola.cor[1],bola.cor[2]);
      glTranslatef(bola.p[0],bola.p[1],bola.p[2]);
      glutSolidSphere(2*raioBola, 9, 6);  
      glPopMatrix();
    }
  }
  //atualiza
  for (unsigned i=0; i<bolas.size(); i++) {
    BOLA& bola=bolas[i];
    if (bola.age<maxAge) {
      bola.p=bola.p+bola.v/fps;
      if (bola.p[1]<raioBola) {
        bola.p[1]=raioBola;
        bola.v=Vec3f(0.95*bola.v[0],-0.7*bola.v[1],0.95*bola.v[2]);
      }
      else bola.v=bola.v+gravidade/fps;
      bola.age++;
    }
  }
  //acrescenta
  int inseri=0;
  for (unsigned i=0; i<bolas.size(); i++) {
    if (bolas[i].age>=maxAge) {
      bolas[i]=BOLA();
      inseri++;
      if (inseri>=bolasPorQuadro) break;
    }
  }
  while (inseri<bolasPorQuadro) {
    bolas.push_back(BOLA());
    inseri++;
  }
}

void desenha(void)
{ for (int x=-12; x<12; x++)
    for (int z=-12; z<12; z++) {
      if ((x+z)%2==0) quadrado(x,z,0.6,0.85,0.85);
      else quadrado(x,z,0.3,1.0,1.0);
    }

  desenhaAtualizaBolas();  

  material(0.7,0.4,0.4);
  glTranslatef(0,0.5,0);
  glutSolidCube(1);
}

void display(void)
{ glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  glPushMatrix(); // Salva a transformacao atual na pilha
  glRotatef(olho,0,1,0);
  desenha();
  glPopMatrix(); // Restaura a transformacao antes da rotacao

  glutSwapBuffers();

//   glReadPixels(0, 0, nc, nl, GL_RGB, GL_UNSIGNED_BYTE, imagem.data); 
//   flip(imagem,imagem,0);
//   cvtColor(imagem,imagem,CV_RGB2BGR);
//   video << imagem; 
}

void spinDisplay(int value)
{ olho += olhoM;
  if (olho>360) olho=olho-360;
  glutTimerFunc(round(duracaoMs),spinDisplay,0);
  glutPostRedisplay();
}

void reshape(int w, int h)
{ glViewport(0, 0, (GLsizei) w, (GLsizei) h);
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(30.0, (GLfloat) w/(GLfloat) h, 0.2, 500); 
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();        
  gluLookAt(0.0, 4.0, 18.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
}

void init(void) 
{ glClearColor(0.1, 0.1, 0.1, 1.0); 
  glShadeModel(GL_SMOOTH);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_LIGHTING);
  GLfloat light_position0[] = { 0.0, 10.0, 4.0, 1.0 };
  glLightfv(GL_LIGHT0, GL_POSITION, light_position0);
  glEnable(GL_LIGHT0);

//   video.open("fonte8.avi",
//           CV_FOURCC('X','V','I','D'), // MPEG4
//           fps,Size(nc,nl)
//          ); 
//   imagem.create(nl,nc);
//   glReadBuffer(GL_FRONT);
}

void keyboard(unsigned char key, int x, int y)
{ if (key==27) exit(0); }

int main(int argc, char** argv)
{ glutInit(&argc, argv);
  glutInitDisplayMode (GLUT_DOUBLE|GLUT_RGB|GLUT_DEPTH);
  nc=640*2; nl=480*2;
  glutInitWindowSize(nc,nl); 
  glutInitWindowPosition(0, 0);
  glutCreateWindow(argv[0]);
  init();
  glutDisplayFunc(display); 
  glutReshapeFunc(reshape); 
  glutTimerFunc(round(duracaoMs),spinDisplay,0);
  glutKeyboardFunc(keyboard);
  glutMainLoop();
  return 0;   
}

