#include <cekeikon.h>
#include <omp.h> 

//Deve setar variavel ambiente
//set OMP_NUM_THREADS=8
//Caso contrario, assume o melhor?

Mat_<GRY> negative(const Mat_<GRY>& a) {
  Mat_<GRY> b(a.rows,a.cols);
  #pragma omp parallel for
  for (unsigned i=0; i<a.total(); i++)
    b(i)=255-a(i);
  return b;
}

int main(int argc, char** argv) {
  Mat_<GRY> a;
  le(a,"flower.jpg");
  Mat_<GRY> b;
  cout << "Numero de threads=" << omp_get_num_procs() << endl;
  omp_set_num_threads( omp_get_num_procs() );
  chronometer( argv[0], b=negative(a), 5, 1000 );
  imp(b,"omp_neg_i.jpg");
}
