#include <cekeikon.h>
#include <thread>

//Deve setar variavel ambiente
//set OMP_NUM_THREADS=8
//Caso contrario, assume o melhor?

namespace THR_NEG_I {

const Mat_<GRY>* ap;
Mat_<GRY>  b;
int nthreads;

void _negative(int t) {
  int m=teto(int(b.total()),nthreads); 
  unsigned inic=t*m;
  unsigned fim=min( (t+1)*m, int(b.total()) );
  for (unsigned i=inic; i<fim; i++)
    b(i)=255-(*ap)(i);
}

}

Mat_<GRY> negative(const Mat_<GRY>& _a) {
  using namespace THR_NEG_I;
  ap=&_a;
  b.create(_a.rows,_a.cols);
  vector<thread> threads(nthreads);
  for (int t=0; t<nthreads; t++)
    threads[t] = thread{_negative,t};
  for (int t=0; t<nthreads; t++) threads[t].join();
  return b;
}

int main(int argc, char** argv) {
  Mat_<GRY> a;
  le(a,"flower.jpg");
  Mat_<GRY> b;
  THR_NEG_I::nthreads=thread::hardware_concurrency();
  cout << "Numero de threads=" << THR_NEG_I::nthreads << endl;
  chronometer( argv[0], b=negative(a), 5, 1000 );
  imp(b,"thr_neg_i.jpg");
}

