//classif.cpp
//compila -t classif
#include "tiny_dnn/tiny_dnn.h"
using namespace tiny_dnn;
using namespace tiny_dnn::activation;
using namespace tiny_dnn::layers;
using namespace std;

int main() {
  network<sequential> net;
  gradient_descent opt;
  opt.alpha  = 1; // learning rate
  
  vector<vec_t> ax { {0.9, 0.1}, {0.1, 0.9} };
  vector<label_t> ay { 0, 1 };
  
  net << fc(2, 2) << sigmoid()
      << fc(2, 2) << softmax();

  int batch_size = 2;
  int epochs = 20000;
  net.train<mse>(opt, ax, ay, batch_size, epochs);

  vector<vec_t> qx { {0.9, 0.1}, {0.1, 0.9}, {0.8, 0.0}, {0.2, 0.9} };
  for (unsigned i=0; i<qx.size(); i++) {
    label_t result=net.predict_label(qx[i]);
    cout << result << endl;
  }
}
