//pyrad.cpp: Executa python3 no arquivo especificado
#include <string>
#include <iostream>
#if defined(_WIN32) || defined(WIN32) || defined(_WIN64)
  #include <windows.h>
#endif
#if defined(linux)
  #include <limits.h>
  #include <unistd.h>
#endif
using namespace std;

void erro(string st) {
  cerr << st << endl;
  exit(0);
}

inline int max3(int a, int b, int c)
{ return max(max(a,b),c); }

string getExePath() {
#if defined(_WIN32) || defined(WIN32) || defined(_WIN64)
    char result[ MAX_PATH ];
    return string( result, GetModuleFileName( NULL, result, MAX_PATH ) );
  #endif
  #if defined(linux)
    string getexepath();
    char result[ PATH_MAX ];
    ssize_t count = readlink( "/proc/self/exe", result, PATH_MAX );
    return string( result, (count > 0) ? count : 0 );
  #endif
}

string sufixo(string st)
// Devolve sufixo "c:\ab\cd.ext => ext"
{ size_t comp=st.length();
  if (comp<=0 || comp>255) erro("Erro sufixo: nome arquivo invalido "+st);
  size_t ponto=st.find_last_of('.');
  string suf;
  if (ponto==size_t(-1)) suf=""; // Arquivo sem extensao
  else suf=st.substr(ponto+1);
  return suf;
}

string semSufixo(string st)
// Devolve o nome do arquivo sem sufixo (e sem .) "c:\ab\cd.ext => c:\ab\cd"
{ size_t comp=st.length();
  if (comp<=0 || comp>255) erro("Erro semSufixo: nome arquivo invalido "+st);
  size_t ponto=st.find_last_of('.');
  string sem;
  if (ponto==size_t(-1)) sem=st; // Arquivo sem extensao
  else sem=st.substr(0,ponto);
  return sem;
}

string diretorio(string st)
// retorna o string antes do ultimo \ ou / ou : "c:\ab\cd.ext => c:\ab"
{ int i1=(int)st.rfind('\\');
  int i2=(int)st.rfind('/');
  int i3=(int)st.rfind(':');
  int i=max3(i1,i2,i3);
  if (i>=0) return st.substr(0,i);
  else return "";
}

int main(int argc, char** argv) {
  if (argc<2) {
    printf("PyRad: Executa python/python3 NomeProg.py no mesmo diretorio do PyRad executavel\n");
    printf("PyRad NomeProg [param1 param2 ...]\n");
    erro("Erro: Numero de argumentos invalido");
  }

  string exePath=diretorio(getExePath());
  string comando;
  #if defined(_WIN32) || defined(WIN32) || defined(_WIN64)
    comando="python";
  #endif
  #if defined(linux)
    comando="python3";
  #endif

  string suf=sufixo(argv[1]);
  string nomeProg;
  if (suf=="") nomeProg=string(argv[1])+".py";
  else if (suf=="py") nomeProg=string(argv[1]);
  else erro("Erro: sufixo invalido: "+suf);

  #if defined(_WIN32) || defined(WIN32) || defined(_WIN64)
    nomeProg=exePath+"\\"+nomeProg;
  #endif
  #if defined(linux)
    nomeProg=exePath+"/"+nomeProg;
  #endif

  comando=comando+" "+nomeProg;

  for (int i=2; i<argc; i++) {
    comando = comando + " " + argv[i];
  }

  cout << comando << endl;
  int e=system(comando.c_str());
}

