#include "bib.h"
int _CRT_glob = 0;   // Para impedir expansao de wildcard

//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
string maiuscula(string st) {
  for (unsigned i=0; i<st.length(); i++)
    st[i]=toupper(st[i]);
  return st;
}

void erro(string s1, string s2, string s3) { 
  cout << s1 << s2 << s3 << endl;
  exit(1);
}

void imp(int argc, char** argv) {
  for (int i=0; i<argc; i++)
    printf("argv[%d]=%s\n",i,argv[i]);
  printf("\n");
}

string leArq(string nome) {
  ifstream ent(nome);
  string linha, arquivo;
  while (!ent.eof()) {
    getline(ent,linha);
    arquivo = arquivo + " " + linha;
  }
  return arquivo;
}

int centseg() {
  return (int)(100.0*clock()/CLOCKS_PER_SEC);
}

void colorPrint(string st, int f, int b) {
// f de 0 a 15
// b de 0 a 7 no Linux e 0 a 15 no Windows
  rlutil::saveDefaultColor();
  if (f>=0) rlutil::setColor(f);
  if (b>=0) rlutil::setBackgroundColor(b);
  cout << st;
  rlutil::resetColor();
}

string getEnv(const string& name) {
// Get env var value
  const char* val = getenv( name.c_str() );
  return val == 0 ? "" : val;
}

string minuscula(string st)
{ for (unsigned i=0; i<st.length(); i++)
    st[i]=tolower(st[i]);
  return st;
}

bool existeArq(string nome) {
  struct stat buffer;   
  return (stat (nome.c_str(), &buffer) == 0); 
}

string sufixo(string st) 
// Devolve sufixo "c:\ab\cd.ext => ext"
{ size_t comp=st.length();
  if (comp<=0 || comp>255) erro("Erro sufixo: nome arquivo invalido",st.c_str());

  size_t ponto=st.find_last_of('.');

  string suf;
  if (ponto==size_t(-1)) suf=""; // Arquivo sem extensao
  else suf=st.substr(ponto+1);

  return suf;
}

string semSufixo(string st) 
// Devolve o nome do arquivo sem sufixo (e sem .) "c:\ab\cd.ext => c:\ab\cd"
{ size_t comp=st.length();
  if (comp<=0 || comp>255) erro("Erro semSufixo: nome arquivo invalido",st.c_str());
  size_t ponto=st.find_last_of('.');
  string sem;
  if (ponto==size_t(-1)) sem=st; // Arquivo sem extensao
  else sem=st.substr(0,ponto);
  return sem;
}

string semDiret(string st) 
// retorna o string depois do ultimo \ ou / ou : "c:\ab\cd.ext => cd.ext"
{ 
  int i1=(int)st.rfind('\\');
  int i2=(int)st.rfind('/');
  int i3=(int)st.rfind(':');
  int i=max3(i1,i2,i3)+1;
  return st.substr(i,st.length()-i);
}

string diretorio(string st) 
// retorna o string minuscula antes do ultimo \ ou / ou : "c:\ab\cd.ext => c:\ab"
{ 
  int i1=(int)st.rfind('\\');
  int i2=(int)st.rfind('/');
  int i3=(int)st.rfind(':');
  int i=max3(i1,i2,i3);
  if (i>=0) return st.substr(0,i);
  else return "";
}

#ifdef _WIN64
void vsWildCard(string nome, vector<string>& vs, bool addNotFound)
{ struct _finddata_t f;
  string nomearq=semDiret(nome);
  string nomedir=diretorio(nome);
  intptr_t handle, done;
  handle = done = _findfirst(nome.c_str(), &f);
  if (done==-1 && addNotFound) vs.push_back(nome);
  while (done!=-1) {
    if (nomedir!="") vs.push_back(nomedir+'\\'+f.name);
    else vs.push_back(f.name);
    done = _findnext(handle, &f);
  }
  _findclose(handle);
}
#endif

//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
void ArgVS::arg2vs(int argc, char** argv) {
  for (int i=0; i<argc; i++) {
    string st=argv[i];
    vs.push_back(st);
  } 
  if (expandeRun) {
    for (int i=1; i<argc; i++) {
      string run;
      if ( vs[i].find("-run=")==0 ) run=vs[i].substr(5);
      if ( vs[i][0]=='`') {
        if (vs[i][ vs[i].length()-1 ]!='`') 
          erro("Error: Enclose argument \"`...`\"");
        run=vs[i].substr(1, vs[i].length()-2);
      }
      if (run!="") { 
        //cout << "run=" << run << endl;
        run += " > _util_edvar.txt";
        system(run.c_str());
        string st = leArq("_util_edvar.txt");
        vs[i]=st;
      }
    }
  }
}

void ArgVS::imp() {
  for (unsigned i=0; i<vs.size(); i++) {
    cout << i << " " << vs[i] << endl;
  }
  cout << endl;
}

//<<<<<<<<<<<<<<<<<<<< Leitura de ArgStr <<<<<<<<<<<<<<<<<<<<<<<<<<<
void ArgComando::converteSt(string& st) {
  for (unsigned i=0; i<st.length(); i++) {
    char& ch=st[i];
    if (exclamacao2porcentagem && ch=='!') ch='%';
    if (apostrofe2aspas && ch=='\'') ch='"';
  }
}

Comando ArgComando::separaComando(const string& st) {
  Comando comando{"","",false};
  if (st!="") {
    if (st.find_first_of(indicadorComando)==0) { // aparece '-' na posicao zero
      size_t i=st.find_first_of(separador);
      if (i==string::npos) { // nao ha separador
        comando.first=st;
      } else { // separador na posicao i
        comando.first=st.substr(0,i);
        comando.second=st.substr(i+1);
      }
    } else { // nao aparece '-' na posicao zero. Usa 2 numeros: 00, 01, etc
      char vet[8];
      sprintf(vet,"%02d",nameless++);
      comando.first=string(vet);
      comando.second=st;
    }
  }
  return comando;
}

void ArgComando::arg2comando(int argc, char** argv) {
  if (expandeRun) {
    ArgVS vs(argc,argv,true);
    vs2comando(vs);
  } else {
    for (int i=1; i<argc; i++) {
      string st=argv[i];
      converteSt(st);
      Comando comando=separaComando(st);
      vs.push_back(comando);
    } 
  }
}

void ArgComando::vs2comando(const ArgVS& arg) {
  for (int i=1; i<int(arg.vs.size()); i++) {
    string st=arg.vs[i];
    converteSt(st);
    Comando comando=separaComando(st);
    vs.push_back(comando);
  } 
}

void ArgComando::imp() {
  for (unsigned i=0; i<vs.size(); i++) {
    cout << vs[i].first << " = " << vs[i].second << endl;
  }
  cout << endl;
}

int ArgComando::procura(const string& nome1, const string& nome2) {
  int i;
  for (i=0; i<int(vs.size()); i++) 
    if (vs[i].first==nome1 || vs[i].first==nome2) {
      break;  
    }
  if (i==int(vs.size())) i=-1;
  else vs[i].chequei=true;
  return i;
}

bool ArgComando::getBool(const string& nome1, const string& nome2, bool def) { 
  int pos=procura(nome1,nome2);
  if (pos<0) return def;

  bool b=true;
  string st=maiuscula(vs[pos].second);
  //if (st=="FALSE") b=false;
  //else if (st=="TRUE") b=true;
  //else b=true;
  if (st=="FALSE") b=false;
  else if (st=="TRUE") b=true;
  else if (st=="") b=true;
  else erro("Erro: Booleano "+vs[pos].first+" deve ser true ou false");
  return b;
}

int ArgComando::getInt(const string& nome1, const string& nome2, int def) {
  int pos=procura(nome1,nome2);
  if (pos<0) return def;
  int sai;
  if (sscanf(vs[pos].second.c_str(),"%d",&sai)!=1) 
    erro("Error: Integer conversion "+vs[pos].first);
  return sai;
}

double ArgComando::getDouble(const string& nome1, const string& nome2, double def) {
  int pos=procura(nome1,nome2);
  if (pos<0) return def;
  double sai;
  if (sscanf(vs[pos].second.c_str(),"%lf",&sai)!=1) 
    erro("Error: Double conversion "+vs[pos].first);
  return sai;
}

float ArgComando::getFloat(const string& nome1, const string& nome2, float def) {
  int pos=procura(nome1,nome2);
  if (pos<0) return def;
  float sai;
  if (sscanf(vs[pos].second.c_str(),"%f",&sai)!=1) 
    erro("Error: Float conversion "+vs[pos].first);
  return sai;
}

string ArgComando::getString(const string& nome1, const string& nome2, string def) {
  int pos=procura(nome1,nome2);
  if (pos<0) return def;
  return vs[pos].second;
}

string ArgComando::getCommand(int indice) {
  char cstr[16];
  sprintf(cstr,"%02d",indice);
  int pos=procura(string(cstr));
  if (pos<0) erro("Error: There is no command #"+string(cstr));
  return vs[pos].second;
}

void ArgComando::leuTodos() {
  for (int i=0; i<int(vs.size()); i++) {
    if (vs[i].chequei==false) 
      erro("Error: Invalid extra command "+vs[i].first+" "+vs[i].second);
  }
}
