#include "rlutil.h"
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <climits>
#include <utility>
#include <ctime>
#include <cfloat>
#include <sys/stat.h>

#ifdef _WIN64
  #include <windows.h>
  #include <dos.h>
  #include <conio.h>
#endif

using namespace std;

string maiuscula(string st);
void erro(string s1, string s2="", string s3="");
void imp(int argc, char** argv);
string leArq(string nome);
int centseg();
void colorPrint(string st, int f=-1, int b=-1);
string getEnv(const string& name);
string minuscula(string st);
bool existeArq(string nome);
string sufixo(string st); // Devolve sufixo "c:\ab\cd.ext => ext"
string semSufixo(string st); // Devolve o nome do arquivo sem sufixo (e sem .) "c:\ab\cd.ext => c:\ab\cd"
inline int max3(int a, int b, int c) { return max(max(a,b),c); }
string semDiret(string st); // retorna o string depois do ultimo \ ou / ou : "c:\ab\cd.ext => cd.ext"
string diretorio(string st); // retorna o string antes do ultimo \ ou / ou : "c:\ab\cd.ext => c:\ab"
#ifdef _WIN64
void vsWildCard(string nome, vector<string>& vs, bool addNotFound=false);
#endif

//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
class ArgVS { // argv[0] e' armazenado
 public:
  vector<string> vs;
  bool expandeRun=true;
  void arg2vs(int argc, char** argv); // converte todos os argv para vs. 
  ArgVS() {}
  ArgVS(int argc, char** argv, bool _expandeRun=true) { expandeRun=_expandeRun; arg2vs(argc,argv); } 
  void imp(); 
};

//<<<<<<<<<<<<<<<<<<<< Leitura de ArgStr <<<<<<<<<<<<<<<<<<<<<<<<<<<
// Nota: Devolve minuscula e maiuscula, sem fazer conversao de caso
class Comando { public: string first; string second; bool chequei; }; 

class ArgComando { // argv[0] nao e' armazenado
 public:
  bool exclamacao2porcentagem=true; // Converte ! para %
  bool apostrofe2aspas=true; // Converte ' para "
  bool expandeRun=true;

  ArgComando() {}
  ~ArgComando() { leuTodos(); }
  void arg2comando(int argc, char** argv); // converte todos os argv para vs. 
  ArgComando(int argc, char** argv, bool _expandeRun=true) { expandeRun=_expandeRun; arg2comando(argc,argv); } 
  // converte todos os argv para vs. Ex: ArgStr(argc-1,&argv[1]).
  void vs2comando(const ArgVS& arg);  
  ArgComando(const ArgVS& arg, bool _expandeRun=true) { expandeRun=_expandeRun; vs2comando(arg); }
  void imp();

  bool getBool(const string& nome1, const string& nome2="", bool def=false); 
  // Sem argumento ou seguido de true/false. So presenca indica true.
  int getInt(const string& nome1, const string& nome2="", int def=INT_MIN);
  double getDouble(const string& nome1, const string& nome2="", double def=-DBL_MAX);
  float getFloat(const string& nome1, const string& nome2="", float def=-FLT_MAX);
  string getString(const string& nome1, const string& nome2="", string def="");
  string getCommand(int indice); 
  // Indice comeca do zero. Devolve comando sem -nome
  void leuTodos();
  // Gera erro se algum comando nao tiver sido checado. Deve chamar apos todos os gets

  int nameless=0; //numero de comandos sem "-"
 private:
  const string separador="="; 
  const string indicadorComando="-";  
  vector< Comando > vs; //nome do comando + argumentos. Ex: -f=2.4 => -f 2.4;  nome.cpp => -0 nome.cpp
  void converteSt(string& st);
  Comando separaComando(const string& st);
  int procura(const string& nome1, const string& nome2=""); // devolve -1 se nao acha
};

