#include "bib.h"

//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< run <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
void run(int argc, char** argv)
{ if (argc<2) {
    printf("Run: Executa com expansao de comando\n");
    printf("Run nome_comando [param1 param2 ...] [-d direxe] [-e direxe] [-t] [-k]\n");
    printf("  -d direxe=vai para diretorio direxe, executa e volta\n");
    printf("  -e direxe=concatena direxe com nome_comando e executa\n");
    printf("  -t=cronometra tempo de execucao\n");
    printf("  -k=espera apertar uma tecla no fim\n");
    printf( "%s\n", R"(  ! convertido para % )" );
    printf( "%s\n", R"(  ' convertido para " )" );
    printf( "%s\n", R"(  -run="comando param" ou "`comando param`" para executar )" );
    printf( "%s\n", R"(Ex: util run gcc "`pkg-config opencv --libs`" )" );
    printf( "%s\n", R"(Ex: util run gcc -run="pkg-config opencv --libs" )" );
    return;
  }

  ArgComando comando(argc,argv);

  bool tempo=comando.getBool("-t","-time");
  bool key=comando.getBool("-k","-key");
  string ddirexe=comando.getString("-d","-dir");
  string edirexe=comando.getString("-e","-exe");

  string st="call ";
  if (edirexe=="") st = st + comando.getCommand(0);
  else st = st + edirexe + "\\" + comando.getCommand(0);
  for (int i=1; i<comando.nameless; i++) {
    st = st + " " + comando.getCommand(i);
  }
  comando.leuTodos();

  if (ddirexe!="") st = "pushd " + ddirexe + " & " + st + " & popd";

  int t1=centseg();
  cout << st << endl;
  system(st.c_str());
  int t2=centseg();

  if (tempo) printf("Tempo gasto %d.%02d segundos\n",(t2-t1)/100,(t2-t1)%100);
  if (key) { printf("Aperte alguma tecla: "); getch(); }
}
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< colorecho <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
void colorecho(int argc, char** argv) {
  if (argc<2) {
    printf("ColorEcho: Imprime uma linha em cores e retorna a cor normal\n");
    printf("ColorEcho codHexaCor texto.\n");
    printf("  Ex: ColorEcho 0c Texto em vermelho.\n");
    printf("  Ex: ColorEcho 0f Texto em branco.\"\n");
  }

  int codCor;
  sscanf(argv[1],"%x",&codCor);

  string st;
  for (int i=2; i<argc-1; i++) {
    st = st + argv[i] + " ";
  }
  st = st + argv[argc-1] + "\n";
  colorPrint(st,codCor);
}

//<<<<<<<<<<<<<<<<<<<<<<<<<<<<< pergunta <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
void pergunta(int argc, char** argv)
{ if (argc<2) {
    printf("Pergunta codHexaCor texto_pergunta\n");
    printf("  Retorna erro 0 se responde S\n");
    printf("          erro 1 se responde N\n");
    printf("  codHexaCor==-1 para nao mudar cor.\n");
    printf("Ex: >ColorPerg C0 Continua\n");
    printf("    >Continua (S/N)?");
    exit(2);
  }

  int codCor;
  sscanf(argv[1],"%x",&codCor);

  string st;
  for (int i=2; i<argc-1; i++) {
    st = st + argv[i] + " ";
  }
  st = st + argv[argc-1];

  colorPrint(st+" (S/N)? ", codCor);
  int ch;
  do {
    ch=toupper(getchar());
  } while (ch!='S' && ch!='N');
 
  if (ch=='S') exit(0);
  else exit(1);
}

//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< main <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
string about=
"< Util: Programas para auxiliar CMD do Windows. v1.06 (2015). Hae Yong Kim.>\n"
"_______________________________________________________________________________\n";

string help=
"Run       - Executa com expansao (ex: PKG-CONFIG).\n"
"ColorEcho - Imprime uma linha em cores e retorna a cor normal.\n"
"Pergunta  - Pergunta com cores S/N.\n"
"...............................................................................\n";

int main(int argc, char** argv)
{ 
  if (argc<2) {
    cout << about;
    cout << help;
    erro("Erro: Numero de argumentos invalido");
  } else {
    string comando=strlwr(argv[1]);
    if      (comando=="run")       run(argc-1,&argv[1]);
    else if (comando=="colorecho") colorecho(argc-1,&argv[1]);
    else if (comando=="pergunta")  pergunta(argc-1,&argv[1]);
    else erro("Erro: Programa inexistente ",comando);
  }
}

